<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleMarkerTracking10DOF.m</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleMarkerTracking10DOF_8m-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleMarkerTracking10DOF.m</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is a simple example of using a marker tracking goal.</p>
<div class="fragment"><div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% <a class="code" href="namespaceOpenSim.html">OpenSim</a> Moco: exampleMarkerTracking10DOF.m                                 %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line">% Copyright (c) 2017 Stanford University and the Authors                     %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Author(s): Nicholas Bianco                                                 %</div>
<div class="line">%                                                                            %</div>
<div class="line">% Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    %</div>
<div class="line">% not use <span class="keyword">this</span> file except in compliance with the License. You may obtain a  %</div>
<div class="line">% copy of the License at http:<span class="comment">//www.apache.org/licenses/LICENSE-2.0          %</span></div>
<div class="line">%                                                                            %</div>
<div class="line">% Unless required by applicable law or agreed to in writing, software        %</div>
<div class="line">% distributed under the License is distributed on an <span class="stringliteral">&quot;AS IS&quot;</span> BASIS,          %</div>
<div class="line">% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   %</div>
<div class="line">% See the License <span class="keywordflow">for</span> the specific language governing permissions and        %</div>
<div class="line">% limitations under the License.                                             %</div>
<div class="line">% -------------------------------------------------------------------------- %</div>
<div class="line"> </div>
<div class="line">function exampleMarkerTracking10DOF()</div>
<div class="line"> </div>
<div class="line">import org.opensim.modeling.*;</div>
<div class="line"> </div>
<div class="line">% Create the 10-DOF skeletal model.</div>
<div class="line">% =================================</div>
<div class="line">% Load the base model from file.</div>
<div class="line">scriptdir = fileparts(mfilename(&#39;fullpath&#39;));</div>
<div class="line">model = Model(fullfile(scriptdir, <span class="stringliteral">&#39;subject01.osim&#39;</span>));</div>
<div class="line"> </div>
<div class="line">% Add CoordinateActuators <span class="keywordflow">for each</span> DOF in the model <span class="keyword">using</span> a </div>
<div class="line">% convenience <span class="keyword">function</span>. See below <span class="keywordflow">for</span> details.</div>
<div class="line">addCoordinateActuator(model, <span class="stringliteral">&#39;lumbar_extension&#39;</span>, 100);</div>
<div class="line">addCoordinateActuator(model, <span class="stringliteral">&#39;pelvis_tilt&#39;</span>, 100);</div>
<div class="line">addCoordinateActuator(model, <span class="stringliteral">&#39;pelvis_tx&#39;</span>, 200);</div>
<div class="line">addCoordinateActuator(model, <span class="stringliteral">&#39;pelvis_ty&#39;</span>, 1500);</div>
<div class="line">addCoordinateActuator(model, <span class="stringliteral">&#39;hip_flexion_r&#39;</span>, 50);</div>
<div class="line">addCoordinateActuator(model, <span class="stringliteral">&#39;knee_angle_r&#39;</span>, 20);</div>
<div class="line">addCoordinateActuator(model, <span class="stringliteral">&#39;ankle_angle_r&#39;</span>, 5);</div>
<div class="line">addCoordinateActuator(model, <span class="stringliteral">&#39;hip_flexion_l&#39;</span>, 50);</div>
<div class="line">addCoordinateActuator(model, <span class="stringliteral">&#39;knee_angle_l&#39;</span>, 20);</div>
<div class="line">addCoordinateActuator(model, <span class="stringliteral">&#39;ankle_angle_l&#39;</span>, 5);</div>
<div class="line"> </div>
<div class="line">% Create MocoStudy.</div>
<div class="line">% ================</div>
<div class="line">study = MocoStudy();</div>
<div class="line">study.setName(<span class="stringliteral">&#39;marker_tracking_10dof&#39;</span>);</div>
<div class="line"> </div>
<div class="line">% Define the optimal control problem.</div>
<div class="line">% ===================================</div>
<div class="line">problem = study.updProblem();</div>
<div class="line"> </div>
<div class="line">% Model (dynamics).</div>
<div class="line">% -----------------</div>
<div class="line">problem.setModel(model);</div>
<div class="line"> </div>
<div class="line">% Bounds.</div>
<div class="line">% -------</div>
<div class="line">% All bounds for coordinate position values and actuator controls are set </div>
<div class="line">% based on model default ranges. The coordinate speeds are set to [-50, 50]</div>
<div class="line">% by the problem as a default. All of these values can be modified on the </div>
<div class="line">% problem itself. For example,</div>
<div class="line">%   problem.setStateInfo(&#39;joint/coord/value&#39;, [-10, 10]);</div>
<div class="line">%   problem.setStateInfo(<span class="stringliteral">&#39;joint/coord/speed&#39;</span>, [-30, 30]);</div>
<div class="line">%   problem.setControlInfo(<span class="stringliteral">&#39;actuator&#39;</span>, [0, 1]);</div>
<div class="line">% Only the time bounds need to be <span class="keyword">set</span> here.</div>
<div class="line">problem.setTimeBounds(0, 1.25);</div>
<div class="line"> </div>
<div class="line">% Cost.</div>
<div class="line">% -----</div>
<div class="line">% Create a marker tracking cost term. This term will compute the squared </div>
<div class="line">% difference between the model markers and the experimental markers, </div>
<div class="line">% integrated over the phase.</div>
<div class="line">markerTrackingCost = MocoMarkerTrackingGoal();</div>
<div class="line">markerTrackingCost.setName(<span class="stringliteral">&#39;marker_tracking&#39;</span>);</div>
<div class="line"> </div>
<div class="line">% Create a <span class="keyword">set</span> of marker weights to define the relative importance <span class="keywordflow">for</span></div>
<div class="line">% tracking individual markers.</div>
<div class="line">markerWeights = SetMarkerWeights();</div>
<div class="line">markerWeights.cloneAndAppend(MarkerWeight(<span class="stringliteral">&#39;Top.Head&#39;</span>, 3));</div>
<div class="line">markerWeights.cloneAndAppend(MarkerWeight(<span class="stringliteral">&#39;R.ASIS&#39;</span>, 3));</div>
<div class="line">markerWeights.cloneAndAppend(MarkerWeight(<span class="stringliteral">&#39;L.ASIS&#39;</span>, 3));</div>
<div class="line">markerWeights.cloneAndAppend(MarkerWeight(<span class="stringliteral">&#39;V.Sacral&#39;</span>, 3));</div>
<div class="line">markerWeights.cloneAndAppend(MarkerWeight(<span class="stringliteral">&#39;R.Heel&#39;</span>, 2));</div>
<div class="line">markerWeights.cloneAndAppend(MarkerWeight(<span class="stringliteral">&#39;R.Toe.Tip&#39;</span>, 2));</div>
<div class="line">markerWeights.cloneAndAppend(MarkerWeight(<span class="stringliteral">&#39;L.Heel&#39;</span>, 2));</div>
<div class="line">markerWeights.cloneAndAppend(MarkerWeight(<span class="stringliteral">&#39;L.Toe.Tip&#39;</span>,2));</div>
<div class="line"> </div>
<div class="line">% Create an <a name="_a0"></a><a class="code" href="classOpenSim_1_1MarkersReference.html">OpenSim::MarkersReference</a> from the experimental marker</div>
<div class="line">% trajectories and the marker weights and pass it to the tracking cost. The</div>
<div class="line">% cost term uses <span class="keyword">this</span> marker reference to compute the weighted, squared</div>
<div class="line">% marker tracking error internally.</div>
<div class="line">markersRef = MarkersReference(fullfile(scriptdir, <span class="stringliteral">&#39;marker_trajectories.trc&#39;</span>), ...</div>
<div class="line">    markerWeights);</div>
<div class="line">markerTrackingCost.setMarkersReference(markersRef);</div>
<div class="line"> </div>
<div class="line">% This setting gives the marker tracking cost permission to ignore data in</div>
<div class="line">% the markers reference <span class="keywordflow">for</span> markers that don<span class="stringliteral">&#39;t exist in the model. For</span></div>
<div class="line"><span class="stringliteral">% example, there are anatomical markers in the TRC file that got carried </span></div>
<div class="line"><span class="stringliteral">% over to markers reference that we&#39;</span>d like to ignore, so <span class="keyword">this</span> flag is </div>
<div class="line">% enabled.</div>
<div class="line">markerTrackingCost.setAllowUnusedReferences(<span class="keyword">true</span>);</div>
<div class="line"> </div>
<div class="line">% Add the tracking cost to the problem.</div>
<div class="line">problem.addGoal(markerTrackingCost);</div>
<div class="line"> </div>
<div class="line">% Add a low-weighted control effort cost to reduce oscillations in the </div>
<div class="line">% actuator controls.</div>
<div class="line">controlCost = MocoControlGoal();</div>
<div class="line">controlCost.setWeight(0.001);</div>
<div class="line">problem.addGoal(controlCost);</div>
<div class="line"> </div>
<div class="line">% Configure the solver.</div>
<div class="line">% =====================</div>
<div class="line">solver = study.initCasADiSolver();</div>
<div class="line">solver.set_num_mesh_intervals(20);</div>
<div class="line">solver.set_optim_constraint_tolerance(1e-3);</div>
<div class="line">solver.set_optim_convergence_tolerance(1e-3);</div>
<div class="line"> </div>
<div class="line">solver.setGuess(<span class="stringliteral">&#39;bounds&#39;</span>);</div>
<div class="line"> </div>
<div class="line">% Now that we<span class="stringliteral">&#39;ve finished setting up the tool, print it to a file.</span></div>
<div class="line"><span class="stringliteral">study.print(&#39;</span>marker_tracking_10dof.omoco<span class="stringliteral">&#39;);</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">% Solve the problem.</span></div>
<div class="line"><span class="stringliteral">% ==================</span></div>
<div class="line"><span class="stringliteral">solution = study.solve();</span></div>
<div class="line"><span class="stringliteral">solution.write(&#39;</span>marker_tracking_10dof_solution.sto<span class="stringliteral">&#39;);</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">% Visualize.</span></div>
<div class="line"><span class="stringliteral">% ==========</span></div>
<div class="line"><span class="stringliteral">% The following environment variable is set during automated testing.</span></div>
<div class="line"><span class="stringliteral">if ~strcmp(getenv(&#39;</span>OPENSIM_USE_VISUALIZER<span class="stringliteral">&#39;), &#39;</span>0<span class="stringliteral">&#39;)</span></div>
<div class="line"><span class="stringliteral">    study.visualize(solution);</span></div>
<div class="line"><span class="stringliteral">end</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">% Plot states trajectory solution.</span></div>
<div class="line"><span class="stringliteral">% --------------------------------</span></div>
<div class="line"><span class="stringliteral">set(groot, &#39;</span>defaultTextInterpreter<span class="stringliteral">&#39;, &#39;</span>none<span class="stringliteral">&#39;)</span></div>
<div class="line"><span class="stringliteral">figure;</span></div>
<div class="line"><span class="stringliteral">time = solution.getTimeMat();</span></div>
<div class="line"><span class="stringliteral">states = solution.getStatesTrajectoryMat();</span></div>
<div class="line"><span class="stringliteral">stateNames = solution.getStateNames();</span></div>
<div class="line"><span class="stringliteral">for i = 1:size(states ,2)</span></div>
<div class="line"><span class="stringliteral">    subplot(4, 5, i)</span></div>
<div class="line"><span class="stringliteral">    plot(time, states(:,i), &#39;</span>linewidth<span class="stringliteral">&#39;, 2)</span></div>
<div class="line"><span class="stringliteral">    xlabel(&#39;</span>time (s)<span class="stringliteral">&#39;)</span></div>
<div class="line"><span class="stringliteral">    title(char(stateNames.get(i-1)))</span></div>
<div class="line"><span class="stringliteral">end</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">% Plot controls trajectory solution.</span></div>
<div class="line"><span class="stringliteral">% ----------------------------------</span></div>
<div class="line"><span class="stringliteral">figure;</span></div>
<div class="line"><span class="stringliteral">controls = solution.getControlsTrajectoryMat();</span></div>
<div class="line"><span class="stringliteral">controlNames = solution.getControlNames();</span></div>
<div class="line"><span class="stringliteral">for i = 1:size(controls ,2)</span></div>
<div class="line"><span class="stringliteral">    subplot(2, 5, i)</span></div>
<div class="line"><span class="stringliteral">    plot(time, controls(:,i), &#39;</span>linewidth<span class="stringliteral">&#39;, 2)</span></div>
<div class="line"><span class="stringliteral">    xlabel(&#39;</span>time (s)<span class="stringliteral">&#39;)</span></div>
<div class="line"><span class="stringliteral">    title(char(controlNames.get(i-1)))</span></div>
<div class="line"><span class="stringliteral">end</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">end</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">function addCoordinateActuator(model, coordName, optimalForce)</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">import org.opensim.modeling.*;</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">coordSet = model.updCoordinateSet();</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">actu = CoordinateActuator();</span></div>
<div class="line"><span class="stringliteral">actu.setName([&#39;</span>tau_<span class="stringliteral">&#39; coordName]);</span></div>
<div class="line"><span class="stringliteral">actu.setCoordinate(coordSet.get(coordName));</span></div>
<div class="line"><span class="stringliteral">actu.setOptimalForce(optimalForce);</span></div>
<div class="line"><span class="stringliteral">% Set the min and max control defaults to automatically generate bounds for</span></div>
<div class="line"><span class="stringliteral">% each actuator in the problem.</span></div>
<div class="line"><span class="stringliteral">actu.setMinControl(-1);</span></div>
<div class="line"><span class="stringliteral">actu.setMaxControl(1);</span></div>
<div class="line"><span class="stringliteral">model.addComponent(actu);</span></div>
<div class="line"><span class="stringliteral"></span> </div>
<div class="line"><span class="stringliteral">end</span></div>
<div class="ttc" id="aclassOpenSim_1_1MarkersReference_html"><div class="ttname"><a href="classOpenSim_1_1MarkersReference.html">OpenSim::MarkersReference</a></div><div class="ttdoc">Reference values to be achieved for specified Markers that will be used via optimization and/or track...</div><div class="ttdef"><b>Definition:</b> MarkersReference.h:84</div></div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
